
# MODULE_NAME (required) and OTHER_* (optional) macros s/b defined by caller
MODULE          = $(MODULE_NAME)-module.so
GLUE            =  $(MODULE_NAME)_glue

PROFILE		= #-pg
CFLAGS		= -g -Wall -O2 -fno-strength-reduce -fno-strict-aliasing -Wall $(OTHER_CFLAGS)
ELF_CC		= /usr/bin/gcc
ELF_CFLAGS	= $(PROFILE) $(CFLAGS) -fPIC -I/usr/include -I. -I../..
ELF_COMPILE	= $(ELF_CC) $(ELF_CFLAGS) $(OTHER_CFLAGS) -c
ELFLIB_MAJOR	= $(MODULE)

ELF_MAJOR_VERSION = 1
ELF_MINOR_VERSION = 0.0
ELF_LINK	= /usr/bin/gcc -shared -Wl,-soname#
ELF_DEP_LIBS	= $(DL_LIB) -lm -lc
ELF_LINK_CMD	= $(ELF_LINK),$(ELFLIB_MAJOR) $(ELF_DEP_LIBS)
DL_LIB		= -ldl

CXX		= g++
CXXFLAGS	= $(PROFILE) $(CFLAGS) -fPIC -I/usr/include -I.
CXX_COMPILE	= $(CXX) $(CXXFLAGS) -c
CXX_ELF_LINK	= $(CXX) -shared -Wl,-soname#
CXX_ELF_LINK_CMD= $(CXX_ELF_LINK),$(ELFLIB_MAJOR)
CXX_LIBS	= 

SLIRPROOT	= ../..
SLIRPSCRIPT	= $(SLIRPROOT)/slirp.sl
SLSH		= $(SLIRPROOT)/slsh
SLIRP_DEBUG	=
SLIRP		= $(SLSH) -n $(SLIRPSCRIPT) $(SLIRP_DEBUG)

SLANG_VERSION	= 20005
SLANGLIB	= -Wl,-R/usr/lib -L/usr/lib -lslang

HAVE_F2C	= 0
F2C_INCLUDE	= 
F2C_LIB		= 
FFLAGS		=
FORTRAN_COMPILE =  $(FFLAGS) -c
FORTRAN_LINK	= 

RM		= \rm -f

all: $(PRE_ALL) $(SLSH) $(MODULE) $(OTHER_ALL)

.SUFFIXES: .cc

.c.o:
	$(CC) $(CFLAGS) -c $< -o $@
.cc.o:
	$(CXX_COMPILE) $< -o $@

clean:
	$(RM) *.o *.so *~ $(GLUE).c $(OTHER_CLEAN) errs.msg

distclean: clean
	$(RM) $(OTHER_DISTCLEAN)

# This is intended for internal development use only
WARN_PROTO=-Wstrict-prototypes
WARN_NEX=-Wnested-externs
warnings:
	$(RM) $(GLUE).o
	@echo
	-CFLAGS="-Wall -W -pedantic -Winline -Wmissing-prototypes \
		-I/usr/include  -I. \
		$(WARN_NEX) -Wpointer-arith -Wcast-align -Wshadow \
	    $(WARN_PROTO)" ; export CFLAGS ; \
	$(MAKE) -e $(GLUE).o > /dev/null 2> errs.msg
	@if [ -s errs.msg ] ; then \
	   cat errs.msg ; \
	   false ; \
	fi

$(SLSH):
	@if [ ! -x $(SLSH) ] ; then \
	   (cd $(SLIRPROOT) ; $(MAKE) slsh) ; \
	   if [ ! -x $(SLSH) ] ; then \
		echo "Cannot find/build $(SLSH)." ; \
		false; \
	   fi ; \
	fi
	@echo 
